/* *******************************************************************<pre>
 * 
 * uiDAOvNX
 * 
</pre>********************************************************************/
package order;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import dbUtil.*;
public class OrderDAO {
	private Connection  cnn;
	private DBManager dbManager;
	/** ******************************************************************
	 * RXgN^
	 * @param cnn
	 *********************************************************************/
	public OrderDAO()throws SystemErrException{
		dbManager=DBManager.getDBManager();
		this.cnn=dbManager.getConnection();
	}	
	/** ******************************************************************
	 * 
	 * @param orderNo
	 * @return OrederDTO
	 * @throws SystemErrException
	 *********************************************************************/
	public OrderDTO orderRefer(int orderNo)throws SystemErrException{
		Statement  stmt=null;
		ResultSet rslt=null;
		OrderDTO orderDTO=new OrderDTO();		
		String sql="SELECT * FROM  WHERE 󒍔ԍ=" + orderNo + " ";
		try{
			stmt=cnn.createStatement();
			rslt=stmt.executeQuery(sql);
			while(rslt.next()){	
				orderDTO.setOrderNo(orderNo);
				orderDTO.setOrderDate(rslt.getString("󒍓"));
				orderDTO.setCustomerCode(Integer.parseInt(rslt.getString("ڋqR[h")));
				orderDTO.setEmpCode(Integer.parseInt(rslt.getString("S҃R[h")));
				orderDTO.setProductCode(rslt.getString("iR[h"));
				orderDTO.setOrderAmount(Integer.parseInt(rslt.getString("󒍐")));
				orderDTO.setOrderMoney(Integer.parseInt(rslt.getString("󒍋z")));
				orderDTO.setDeliveryPlace(rslt.getString("[ꏊ"));
				orderDTO.setDeliveryDate(rslt.getString("[\"));				
				break;
			}			
		}catch(Exception e){
			e.printStackTrace();
			throw new SystemErrException();
		}finally{
			try{
				if(rslt != null)rslt. close();
				if(stmt != null)stmt. close();				
			}catch(Exception e){
				e.printStackTrace();
				throw new SystemErrException();
			}			
		}		
		return orderDTO;
		
	}
	/** ***************************************************************
	 * 󒍃R[h̍폜
	 * @param orderNo
	 * @throws SystemErrException
	 ******************************************************************/
	public void orderDelete(int orderNo)throws SystemErrException{
		Statement  stmt=null;
		String sql="DELETE FROM  WHERE 󒍔ԍ=" + orderNo;
		try{
			stmt=cnn.createStatement();
			stmt.executeUpdate(sql);			
			cnn.commit();
			
		}catch(Exception e){
			e.printStackTrace();
			throw new SystemErrException();
		}finally{
			try{
				if(stmt != null)stmt.close();
//				this.cnn.close();
//				this.cnn=dbManager.getConnection();
			}catch(Exception e){
				e.printStackTrace();
				throw new SystemErrException();
			}			
		}		
		return;
	}
	/** *****************************************************************
	 * 󒍃R[hǉ
	 * @param orderDTO
	 * @throws SystemErrException
	 ********************************************************************/
	public void orderInsert(OrderDTO orderDTO)throws SystemErrException{
		Statement  stmt=null;
		String sql="INSERT INTO (󒍔ԍ,󒍓,ڋqR[h,S҃R[h," +
					"iR[h,󒍐,󒍋z,[ꏊ,[\) " +
		           "VALUES(" +
		           orderDTO.getOrderNo() + ",'" + 
		           orderDTO.getOrderDate() + "'," +
		           orderDTO.getCustomerCode() + "," +
		           orderDTO.getEmpCode() + ",'" + 
		           orderDTO.getProductCode() + "'," +
		           orderDTO.getOrderAmount() + "," +
		           orderDTO.getOrderMoney() + ",'" +
		           orderDTO.getDeliveryPlace() + "','" +
		           orderDTO.getDeliveryDate() + "')";		           
		           
		try{
			stmt=cnn.createStatement();
			stmt.executeUpdate(sql);
			cnn.commit();
		}catch(Exception e){
			e.printStackTrace();
			throw new SystemErrException();
		}finally{
			try{
				if(stmt != null)stmt.close();
			}catch(Exception e){
				e.printStackTrace();
				throw new SystemErrException();
			}			
		}		
		return;
	}
	/** ******************************************************************
	 * 󒍃R[hXV
	 * @param orderDTO
	 * @throws SystemErrException
	 *********************************************************************/
	public void orderUpdate(OrderDTO orderDTO)throws SystemErrException{
		Statement  stmt=null;
		String sql="UPDATE  SET " +
				"󒍐=" + orderDTO.getOrderAmount() + "," +
				"󒍋z=" + orderDTO.getOrderMoney() + "," +
				"[ꏊ='"+ orderDTO.getDeliveryPlace() + "'," +
				"[\='" + orderDTO.getDeliveryDate() + "' " + 
				"WHERE 󒍔ԍ=" + orderDTO.getOrderNo();	           
		try{
			stmt=cnn.createStatement();
			stmt.executeUpdate(sql);
			cnn.commit();
		}catch(Exception e){
			e.printStackTrace();
			throw new SystemErrException();
		}finally{
			try{
				if(stmt != null)stmt. close();
			}catch(Exception e){
				e.printStackTrace();
				throw new SystemErrException();
			}			
		}		
		return;
	}
	/** ******************************************************************
	 * ő󒍔ԍ̎擾
	 * @param  Ȃ
	 * @throws SystemErrException
	 *********************************************************************/
	public int orderMaxNo()throws SystemErrException{
		Statement  stmt=null;
		ResultSet rslt=null;
		int retNo=0;
		String sql="SELECT MAX(󒍔ԍ) AS MAXORDER FROM ";		
		try{
			stmt=cnn.createStatement();
			rslt=stmt.executeQuery(sql);
			while(rslt.next()){	
				String maxOrder=rslt.getString("MAXORDER");
				if(maxOrder!=null)retNo=Integer.parseInt(maxOrder);
				break;
			}			
		}catch(Exception e){
			e.printStackTrace();
			throw new SystemErrException();
		}finally{
			try{
				if(stmt != null)stmt. close();
			}catch(Exception e){
				e.printStackTrace();
				throw new SystemErrException();
			}			
		}		
		return retNo;
	}	
	
}
