/* *******************************************************************<pre>
 * 
 * uivNX
 * 
</pre>********************************************************************/
package resource.product;
import _interface.InfProduct;
import dbUtil.*;
import resource.warehouse.*;
public class Product implements InfProduct{
	private String productCode;	//iR[h
	private String productName;	//i
	private int normalPrice;		//WP	
	
	/** ***********************************************************
	 * RXgN^
	 * @param iR[h
	 * @throws SystemErrException
	***************************************************************/
	public Product(String proCode)throws SystemErrException{
		ProductDAO proDAO=new ProductDAO();
		ProductDTO proDTO=proDAO.proSearch(proCode);		
		this.productCode=proDTO.getProductCode();;
		this.productName=proDTO.getProductName();
		this.normalPrice=proDTO.getNormalPrice();
	}
	/** **********************************************************
	 * Qb^[
	 *************************************************************/
	public String getProductCode() {return this.productCode;}
	public String getProductName() {return this.productName;}
	public int getNormalPrice() {return this.normalPrice;}
	public boolean isExist() {
		if(this.productName==null)return false;
		else return true;
		}
	/** *********************************************************
	 * ݌ɏƉ
	 * @param N
	 * @return z[݌ɐC]
	 * @throws SystemErrException
	 ************************************************************/
	public int[] stockInq(String month)throws SystemErrException {
		int[] stock=new int[2];
		Warehouse wh=new Warehouse(productCode,month);		
		stock[0]=wh.getStockQuant();
		stock[1]=wh.getReserveQuant();		
		return stock;
	}
	/** *********************************************************
	 * o
	 * @param oד
	 * @param oא
	 * @return@0:I@-1:ُI
	 * @throws SystemErrException
	 ************************************************************/
	public int shipStock(String date,int quant)throws SystemErrException {
		Warehouse wh=new Warehouse(productCode,date.substring(0,6));
		return wh.shipProduct(date,quant);	
	}
	/** *********************************************************
	 * 
	 * @param oח\
	 * @param oח\萔
	 * @return@0:I@-1:ُI
	 * @throws SystemErrException
	 ************************************************************/
	public int allotStock(String date,int quant)throws SystemErrException {
		Warehouse wh=new Warehouse(productCode,date.substring(0,6));
		return wh.reserveProduct(date,quant);	
	}
}
