/* *******************************************************************<pre>
 * 
 * uivNX
 * 
</pre>********************************************************************/
package stock;
import java.sql.*;
import dbUtil.*;
import resource.product.*;
import _interface.InfProduct;

public class StockBeans{
	private String productCode;		//iR[h
	private String productName;		//i
	private int normalPrice;			//WP	
	private String sMonth;				//
	private String eMonth;				//
	private String[] stockMonth=new String[6];	//݌Ɍ
	private int[] stockQuant=new int[6];	//݌ɐ
	private int[] resrvQuant=new int[6];	//
	private int[] validQuant=new int[6];	//L
	private String message;			//AbZ[W	
	private InfProduct product;			//iCX^Xϐ
	
	public StockBeans(){
		this.productCode="";
		this.productName="";
		this.normalPrice=0;
		this.sMonth="";
		this.eMonth="";
		this.message="";
		for(int i=0;i<6;i++){
			stockMonth[i]="";
			stockQuant[i]=0;
			resrvQuant[i]=0;
			validQuant[i]=0;
		}
	}

	public String getProductCode(){return this.productCode;}
	public String getProductName(){return this.productName;}
	public int getNormalPrice(){return this.normalPrice;}
	public String getSnormalPrice(){if(this.normalPrice==0)return ""; 
									else return Integer.toString(this.normalPrice);}
	public String getStockMonth(int i){return this.stockMonth[i];}
	public int getStockQuant(int i){return this.stockQuant[i];}
	public String getSstockQuant(int i){if(this.stockQuant[i]==0)return ""; 
									else return Integer.toString(this.stockQuant[i]);}
	public int getResrvQuant(int i){return this.resrvQuant[i];}
	public String getSresrvQuant(int i){if(this.resrvQuant[i]==0)return ""; 
									else return Integer.toString(this.resrvQuant[i]);}
	public int getValidQuant(int i){return this.validQuant[i];}
	public String getSvalidQuant(int i){if(this.validQuant[i]==0)return ""; 
									else return Integer.toString(this.validQuant[i]);}	
	public String getMessage(){return this.message;}

	public void setProductCode(String productCode){this.productCode=productCode;}
	public void setProductName(String productName){this.productName=productName;}
	public void setNormalPrice(int normalPrice){this.normalPrice=normalPrice;}
	public void setSMonth(String sMonth){this.sMonth=sMonth;}
	public void setEMonth(String eMonth){this.eMonth=eMonth;}
	public void setStockMonth(int i,String stockMonth){this.stockMonth[i]=stockMonth;}
	public void setStockQuant(int i,int stockQuant){this.stockQuant[i]=stockQuant;}
	public void setResrvQuant(int i,int resrvQuant){this.resrvQuant[i]=resrvQuant;}
	public void setValidQuant(int i,int validQuant){this.validQuant[i]=validQuant;}
	public void setMessage(String message){this.message=message;}
	
	public void exeStockInq() throws SystemErrException{
		int i;
		this.product=new Product(this.productCode);
		if(this.product.isExist()){
			this.productName=this.product.getProductName();
			this.normalPrice=this.product.getNormalPrice();
			//t̃Zbg
			String cMonth=this.sMonth;
			for(i=0;i<6;i++){
				this.stockMonth[i]=cMonth;
				if(cMonth.equals(this.eMonth))break;
				cMonth=addMonth(1,cMonth);
			}
			if(i==6)i-=1;
			for(int j=0;j<=i;j++){
				int[] quant=this.product.stockInq(this.stockMonth[j]);
				this.stockQuant[j]=quant[0];
				this.resrvQuant[j]=quant[1];
				this.validQuant[j]=quant[0]-quant[1];
			}			
			return;
		}else{
			this.setMessage("Y鏤i͂܂B");			
			return;
		}
	}
	/* **********************************************
	 * (֐)̉Z
	 ************************************************/
    private String addMonth(int i,String sMonth){
    	String[] item=sMonth.split("/");
    	int year=Integer.parseInt(item[0]);
    	int month=Integer.parseInt(item[1]);
    	month +=i;
    	if(month>12){
    		month -=12;
    		year +=1;
    	}
    	return Integer.toString(year)+"/"+Integer.toString(month);
    }
}
