package stock;

import java.io.*;
import java.util.Date;
import java.text.*;
import javax.servlet.*;
import javax.servlet.http.*;
import dbUtil.*;


public class StockSrvlt extends HttpServlet {
    public void doPost(HttpServletRequest hreq,
			HttpServletResponse hres)
			throws ServletException,IOException  {    	
    	hreq.setCharacterEncoding("SHIFT-JIS");
    	
    	try{
	    	StockBeans sb=new StockBeans();
	    	String sMonth,eMonth;
	    	/* ***********************************************
	    	* ʍڂBeansւ̃Zbg
	    	*************************************************/
	    	//iR[hݒ
	    	sb.setProductCode(hreq.getParameter("productCode"));
	    	//Ԃ̐ݒ
	    	if(hreq.getParameter("R001").equals("1")){
	    		Date date=new Date();
	    		SimpleDateFormat sdf=new SimpleDateFormat("yyyy/MM");
	    		sMonth=sdf.format(date);
	    		eMonth=addMonth(5,sMonth);	    			
	    	}else{
	    		sMonth=addMonth(0,hreq.getParameter("sDate"));
	    		eMonth=addMonth(0,hreq.getParameter("eDate"));
	    	}
	    	sb.setSMonth(sMonth);
	    	sb.setEMonth(eMonth);
	    	
	    	/* ***********************************************
	    	* ݌ɏƉ
	    	*************************************************/
	    	sb.exeStockInq();
	    	
	    	
	    	/* **********************************************
			 * ʂւ̑J
			 ************************************************/
	    	hreq.setAttribute("stockBeans",sb);
	    	RequestDispatcher rd=hreq.getRequestDispatcher("./view/stock.jsp");
	        rd.forward(hreq,hres);
	        return;
	        
    	}catch(SystemErrException e){
    		/* **********************************************
			 * VXeG[
			 ************************************************/
    		RequestDispatcher rd=hreq.getRequestDispatcher("./view/syserr.jsp");
	        rd.forward(hreq,hres);
	        return;
    	}
    }
    public void doGet(HttpServletRequest hreq,
			HttpServletResponse hres)
			throws ServletException,IOException {
    	/* **********************************************
		 * ʂ̕\
		 ************************************************/
    	hreq.setCharacterEncoding("SHIFT-JIS");
       	StockBeans sb=new StockBeans();
    	hreq.setAttribute("orderBeans",sb);
    	RequestDispatcher rd=hreq.getRequestDispatcher("./view/stock.jsp");
        rd.forward(hreq,hres);
    	
    }
    /* **********************************************
	 * (֐)̉Z
	 ************************************************/
    private String addMonth(int i,String sMonth){
    	String[] item=sMonth.split("/");
    	int year=Integer.parseInt(item[0]);
    	int month=Integer.parseInt(item[1]);
    	month +=i;
    	if(month>12){
    		month -=12;
    		year +=1;
    	}
    	return Integer.toString(year)+"/"+Integer.toString(month);
    }
}
